#ifndef _FACTORIZATION_MATRIX_
#define _FACTORIZATION_MATRIX_
/*
* (c)2017 The University of Aizu
* This software is released under the New BSD License.
*/

#include "local_basic_type.h"

/*=================================================================================================
  Macro definition
 ================================================================================================*/
enum{
	EVENT_IMAGE   = 0          , // image
	EVENT_RESULT1              , // result1
	EVENT_RESULT2              , // result2
	IN_EVENT_MAX               ,
};

enum{
	M_MODE_00     = 0          , // initial value
	M_MODE_01                  , // image
	M_MODE_02                  , // result1
	M_MODE_03                  , // result2
	M_MODE_04                  , // image & result1
	M_MODE_05                  , // image & result2
	M_MODE_06                  , // result1 & result2
	M_MODE_07                  , // input data is complete
  M_MODE_MAX                 ,
};

enum{
	PROC_IMAG     = 0          ,
	PROC_RLT1                  ,
	PROC_RLT2                  ,
	PROC_MAX                   ,
};

#define	NO_EVENT         IN_EVENT_MAX
#define	PROC_MIN         PROC_IMAG
#define	M_MODE_INIT      M_MODE_00
#define	MT_NO_CHG        (0xFFFFu)
#define	MT_NO_MODE       (0xFFFFu)
#define	NO_PROC          (0xFFFFu)

#define	INPUT_DATA_COMP  M_MODE_07

/***************************************************************************************************
 *  Function        : InEventTable_Type
 *  Description     : Table definition
 *  Argument        : nothing special
 *  Return          : nothing special
 **************************************************************************************************/
struct InEventTable_Type
{
  uhword_type uhwNextState;
  uhword_type uhwProcessCode;
};

struct InEventTable_Type nstInEvevtCheck_tbl[][M_MODE_MAX] = {
  { { M_MODE_01, PROC_IMAG }, { MT_NO_CHG, NO_PROC   }, { M_MODE_04, PROC_IMAG }, { M_MODE_05, PROC_IMAG }, { MT_NO_CHG, NO_PROC   }, { MT_NO_CHG, NO_PROC   }, { M_MODE_07, PROC_IMAG }, { MT_NO_CHG, NO_PROC } },
  { { M_MODE_02, PROC_RLT1 }, { M_MODE_04, PROC_RLT1 }, { MT_NO_CHG, NO_PROC   }, { M_MODE_06, PROC_RLT1 }, { MT_NO_CHG, NO_PROC   }, { M_MODE_07, PROC_RLT1 }, { MT_NO_CHG, NO_PROC   }, { MT_NO_CHG, NO_PROC } },
  { { M_MODE_03, PROC_RLT2 }, { M_MODE_05, PROC_RLT2 }, { M_MODE_06, PROC_RLT2 }, { MT_NO_CHG, NO_PROC   }, { M_MODE_07, PROC_RLT2 }, { MT_NO_CHG, NO_PROC   }, { MT_NO_CHG, NO_PROC   }, { MT_NO_CHG, NO_PROC } },
};

#endif
